use reprc_proc_macro::DeriveReprC;

#[macro_export]
macro_rules! impl_reprc {
    (
        $(#[$meta: meta])*
        $v:vis struct $struct_name:ident {
            $( $(#[$field_meta:meta])* $member:ident : $t:ty, )+
        }
    ) => {
        #[repr(C)]
        #[derive(Debug, Clone, DeriveReprC)]
        $(#[$meta])*
        $v struct $struct_name {
            $(
                $( #[$field_meta] )*
                pub $member: $t,
            )+
        }
    };
}

impl_reprc!(
    struct Test {
        #[assume_reprc]
        i1: i32,
        #[assume_reprc]
        i2: i32,
        #[assume_reprc]
        v1: Vec<i32>,
    }
);

pub unsafe trait ReprC {
    fn is_repr_c(&self) -> bool;
}
